package service_award_dividend

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/enum"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/implement"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	"encoding/json"
	"sort"
	"strings"
	"time"
	"xorm.io/xorm"
)

func GetCycle(eg *xorm.Engine) map[string]string {
	NewServiceAwardReturnBaseDb := implement.NewServiceAwardReturnBaseDb(eg)
	base, _ := NewServiceAwardReturnBaseDb.GetServiceAwardReturnBase()
	now := time.Now()
	res := map[string]string{}
	if base != nil {
		res = map[string]string{
			"coin_id": zhios_order_relate_utils.IntToStr(base.CoinId),
		}
		ex := strings.Split(base.Day, ",")
		if len(ex) > 0 {
			day := now.Day()
			hasDay := 0
			sort.Strings(ex)
			postion := 0
			//31
			//    16  20  30
			for k, v := range ex { //判断最近的一天  now 读的是当前周期 就是比当前时间大的一个日期  last 读的是上个周期 就是比当前时间小的一个日期
				if day > zhios_order_relate_utils.StrToInt(v) { //当前时间大于设置时间
					if k+1 == len(ex) {
						postion = k + 1
					}
					continue
				}
				if hasDay == 1 {
					continue
				}
				postion = k
				hasDay = 1
			}
			last := postion - 1
			next := postion
			types := "now"
			types1 := "last"
			if postion-1 < 0 { //找出上一周期的时间
				last = len(ex) - 1
			} else if last == len(ex)-1 { //最后一个了
				next = 0
				types = "next"
				types1 = "now"
			}

			lastDate := GetDate(now, ex[last], types1)
			res["last"] = time.Unix(lastDate, 0).Format("20060102")
			nowDate := GetDate(now, ex[next], types)
			res["now"] = time.Unix(nowDate, 0).Format("20060102")
		}
	}
	return res
}
func GetDate(now time.Time, day, types string) int64 {
	year := now.Year()
	month := now.Month()
	var date int64 = 0
	if types == "last" {
		month--
		if month < 0 {
			month = 12
			year--
		}
	}
	if types == "next" {
		month++
		if month > 12 {
			month = 1
			year++
		}
	}

	date = time.Date(year, month, zhios_order_relate_utils.StrToInt(day), 0, 0, 0, 0, now.Location()).Unix()
	return date
}

func AddPeriod(eg *xorm.Engine, sess *xorm.Session, req map[string]string) int {
	NewServiceAwardReturnBaseDb := implement.NewServiceAwardReturnBaseDb(eg)
	base, _ := NewServiceAwardReturnBaseDb.GetServiceAwardReturnBase()
	if base == nil {
		return 2
	}
	if base.CoinId != zhios_order_relate_utils.StrToInt(req["coin_id"]) {
		return 2
	}
	date := GetCycle(eg)
	period := 0
	switch req["pvd"] {
	case "0":
		period = base.CpsPeriod
		if base.ReturnType == 1 {
			period = base.HandCpsPeriod
		}
		break
	case "1":
		period = base.MallPeriod
		if base.ReturnType == 1 {
			period = base.HandMallPeriod
		}
		break
	case "2":
		period = base.MemberUplvPeriod
		if base.ReturnType == 1 {
			period = base.HandMemberUplvPeriod
		}
		break
	case "3":
		req["price"] = "0"
		period = base.NewMemberPeriod
		if base.ReturnType == 1 {
			period = base.HandNewMemberPeriod
		}
		break
	}
	if period == 0 {
		return 2
	}
	data := models.ServiceAwardReturnFlow{
		Uid:            zhios_order_relate_utils.StrToInt(req["uid"]),
		Time:           time.Now(),
		UpdateTime:     time.Now(),
		Sum:            req["amount"],
		Type:           base.ReturnType,
		HasReturnMoney: "0",
		Period:         period,
		Price:          req["price"],
		EveryMoney:     zhios_order_relate_utils.Float64ToStr(float64(int(zhios_order_relate_utils.StrToFloat64(req["amount"])/float64(period)*100)) / 100),
		Pvd:            zhios_order_relate_utils.StrToInt(req["pvd"]),
		CoinId:         base.CoinId,
		Date:           zhios_order_relate_utils.StrToInt(date["now"]),
		LastDate:       zhios_order_relate_utils.StrToInt(date["last"]),
		Oid:            zhios_order_relate_utils.StrToInt64(req["oid"]),
	}
	insert, err := sess.Insert(&data)
	if insert == 0 || err != nil {
		return 3
	}
	return 1
}
func AddPeriodEg(eg *xorm.Engine, req map[string]string) int {
	NewServiceAwardReturnBaseDb := implement.NewServiceAwardReturnBaseDb(eg)
	base, _ := NewServiceAwardReturnBaseDb.GetServiceAwardReturnBase()
	if base == nil {
		return 2
	}
	if base.CoinId != zhios_order_relate_utils.StrToInt(req["coin_id"]) {
		return 2
	}
	date := GetCycle(eg)
	period := 0
	switch req["pvd"] {
	case "0":
		period = base.CpsPeriod
		if base.ReturnType == 1 {
			period = base.HandCpsPeriod
		}
		break
	case "1":
		period = base.MallPeriod
		if base.ReturnType == 1 {
			period = base.HandMallPeriod
		}
		break
	case "2":
		period = base.MemberUplvPeriod
		if base.ReturnType == 1 {
			period = base.HandMemberUplvPeriod
		}
		break
	case "3":
		req["price"] = "0"
		period = base.NewMemberPeriod
		if base.ReturnType == 1 {
			period = base.HandNewMemberPeriod
		}
		break
	}
	if period == 0 {
		return 2
	}

	data := models.ServiceAwardReturnFlow{
		Uid:            zhios_order_relate_utils.StrToInt(req["uid"]),
		Time:           time.Now(),
		UpdateTime:     time.Now(),
		Type:           base.ReturnType,
		Sum:            req["amount"],
		HasReturnMoney: "0",
		Price:          req["price"],
		Period:         period,
		EveryMoney:     zhios_order_relate_utils.Float64ToStr(float64(int(zhios_order_relate_utils.StrToFloat64(req["amount"])/float64(period)*100)) / 100),
		Pvd:            zhios_order_relate_utils.StrToInt(req["pvd"]),
		CoinId:         base.CoinId,
		Date:           zhios_order_relate_utils.StrToInt(date["now"]),
		LastDate:       zhios_order_relate_utils.StrToInt(date["last"]),
		Oid:            zhios_order_relate_utils.StrToInt64(req["oid"]),
	}
	insert, err := eg.Insert(&data)
	if insert == 0 || err != nil {
		return 3
	}
	return 1
}
func CouponReward(eg *xorm.Engine, uid int) {
	var data []model.MallCouponScheme
	err2 := eg.Where("send_way=4 and left_num>0").Find(&data)
	if len(data) == 0 || err2 != nil {
		return
	}
	for _, v := range data {
		BatchInsertMallUserCoupon(eg, v, uid)
	}
}
func BatchInsertMallUserCoupon(engine *xorm.Engine, mallCouponScheme model.MallCouponScheme, uid int) error {
	user, _ := db.UserFindByID(engine, uid)
	var startTime time.Time
	var endTime time.Time
	var now = time.Now()
	if mallCouponScheme.ValidTimeType == int(enum.MallCouponValidTimeTypeFix) { // 固定日期
		startTime = mallCouponScheme.ValidTimeStart
		endTime = mallCouponScheme.ValidTimeEnd
	} else { // 领取后多少天有效
		startTime = now
		endTime = now.Add(time.Hour * 24 * time.Duration(mallCouponScheme.ValidDayNum))
	}

	var tmp = make([]map[string]interface{}, 0)
	json.Unmarshal([]byte(mallCouponScheme.LvNum), &tmp)
	if len(tmp) == 0 {
		return nil
	}
	for _, v := range tmp {
		if zhios_order_relate_utils.AnyToString(v["id"]) == zhios_order_relate_utils.IntToStr(user.Level) {
			var userCoupons []*model.MallUserCoupon
			tmpData := v
			if mallCouponScheme.LeftNum < 0 {
				mallCouponScheme.LeftNum = 0
			}
			perUserNum := zhios_order_relate_utils.StrToInt(zhios_order_relate_utils.AnyToString(tmpData["count"]))
			leftNum := mallCouponScheme.LeftNum - perUserNum
			if leftNum < 0 {
				perUserNum = mallCouponScheme.LeftNum
				leftNum = 0
			}
			for i := 0; i < perUserNum; i++ {
				var userCoupon = &model.MallUserCoupon{
					Uid:             uid,
					SchemeId:        mallCouponScheme.Id,
					IsUse:           0,
					Kind:            zhios_order_relate_utils.StrToInt(zhios_order_relate_utils.AnyToString(tmpData["kind"])),
					Cal:             zhios_order_relate_utils.SerializeStr(tmpData["cal"]),
					ValidTimeStart:  startTime,
					ValidTimeEnd:    endTime,
					UseRule:         mallCouponScheme.UseRule,
					UseActivityType: mallCouponScheme.UseActivityType,
					CreateTime:      now,
					UpdateTime:      now,
				}
				userCoupons = append(userCoupons, userCoupon)
			}
			if len(userCoupons) == 0 {
				continue
			}
			_, err := engine.Table("mall_user_coupon").Insert(&userCoupons)
			if err != nil {
				return err
			}
			mallCouponScheme.LeftNum = leftNum
			engine.Where("id=?", mallCouponScheme.Id).Cols("left_num").Update(&mallCouponScheme)
		}
	}

	return nil
}
